/*
 * Lesson 01: Setting up a window
 * Inspired by the Nehe examples at nehe.gamedev.net
 */

import groovy.swing.SwingXBuilder
import com.sun.j3d.utils.universe.*
import javax.media.j3d.*
import java.awt.event.*
import javax.swing.WindowConstants

/*
 * @author jwill
 */



class Lesson01 {
    def swing = new SwingXBuilder()
    def config = SimpleUniverse.getPreferredConfiguration();
    def canvas3D = new Canvas3D(config)
    def su = new SimpleUniverse(canvas3D)
    def frame
    def keyListener = [ keyPressed: {evt ->
        int keyCode = evt.getKeyCode()
        if (keyCode == KeyEvent.VK_ESCAPE)
            System.exit(0)
    }, keyReleased: {evt-> }, keyTyped: {evt -> }] as KeyListener

    void setupScene() {
        canvas3D.addKeyListener(keyListener)

        frame = swing.frame(size:[300,200], title:'Lesson 01: Setting up an Java3D Window', defaultCloseOperation: WindowConstants.EXIT_ON_CLOSE) {
            widget(canvas3D)
        }

        swing.doLater() {
            frame.show()
        }
    }

    public static void main(args) {
        new Lesson01().setupScene()
    }
}